#include<fstream>
#include<iostream>
#include<iomanip>
using namespace std;

void main()
{
	fstream dat1("ulaz.txt", ios::in);
	const streamsize MAX_DUZ = 80;
	char line[MAX_DUZ];
	int i, pozicija;
	
	// tellg vraca poziciju unutar ulaznog toka
	// tellp vraca poziciju unutar izlaznog toka (ne koristi se u ovom zadatku)
	pozicija = dat1.tellg(); 
	cout << "Pozicija: " << pozicija << endl;
	
	// prva linija datoteke: "prvi drugi treci cetvrti"
	dat1 >> line; // citamo prvu rec
	cout << line << endl; // "jedan"
	dat1.width(3); 
	dat1 >> line; // citamo 2 znaka sledece reci ili jednu rec ne duzu od dva znaka
	cout << line << endl; // "dv"
	dat1.width(3); 
	dat1 >> line; // citamo 2 znaka sledece reci ili jednu rec ne duzu od dva znaka
	cout << line << endl; // "a"
	dat1.width(3); 
	dat1 >> line; // citamo 2 znaka sledece reci ili jednu rec ne duzu od dva znaka
	cout << line << endl; // "tr"
	dat1.getline(line, MAX_DUZ); // citamo sve do kraja linije; 
	// po zelji, mozemo kao treci argument metode getline zadati znak 
	// koji ce sluziti kao delimiter sa kojim zavrsava citanje
	cout << line << endl; // "i cetiri"

	pozicija = dat1.tellg(); 
	cout << "Pozicija: " << pozicija << endl;
	
	dat1 >> i >> line; // citamo int, pa jednu rec
	cout << i << line << endl; // "21pet"
	dat1.getline(line, MAX_DUZ); // citamo sve do kraja linije
	cout << line << endl; // " sest sedam"

	pozicija = dat1.tellg(); 
	cout << "Pozicija: " << pozicija << endl;
	
	// pomeramo se 10 mesta unapred u odnosu na trenutnu poziciju
	dat1.seekg(10, ios::cur);

	pozicija = dat1.tellg(); 
	cout << "Pozicija: " << pozicija << endl;
	
	// ispis istih brojeva, samo sa razlicitim brojem decimalnih cifara i slovnih mesta
	cout.width(12);
	cout << pozicija << endl; // "          51"
	cout.width(12);  // width se odnosi samo na prvi naredni podatak koji se ispisuje
	cout << "Pozicija: " << pozicija << endl; // "  Pozicija: 51"
	// setw je deklarisan u <iomanip> i isto kao width, odnosi se samo na prvi naredni podatak
	cout << setw(12) << "Pozicija: " << setw(5) << pozicija << endl; // "  Pozicija:    51"

	cout.fill('-'); // fill odredjuje cime ce biti popunjena eventualna prazna mesta u ispisu
	cout.width(10);
	cout << pozicija << endl; // "--------51"
	cout << pozicija << endl; // "51"
	cout.width(5);
	cout.fill('+');
	cout << pozicija << endl; // "+++51"
	// manipulator setfill ima istu ulogu kao metoda fill
	cout << setw(4) << setfill ('0') << pozicija << endl; // "000051"
	
	long coutFlags = cout.flags(); // pamtimo polazno stanje podesavanja za formatiranje
	cout << "Pozicija kao double: " << (double) pozicija << endl; // "Pozicija kao double: 51"
	cout.precision(4); // broj znacajnih cifara koje treba prikazati, odnosi se na svaki naredni ispis racionalnih brojeva
	cout.flags(coutFlags | ios::showpoint); // forsiramo pojavljivanje decimalne tacke
	cout << "Pozicija kao double: " << (double) pozicija << endl; // "Pozicija kao double: 51.00"
	// manipulator setprecision ima istu ulogu kao metoda precision
	cout << "Pozicija kao double: " << setprecision(6) << (double) pozicija << endl; // "Pozicija kao double: 51.0000"
	cout.flags(coutFlags | ios::fixed); // sada se precision odnosi na broj cifara iza decimalne tacke
	cout << "Pozicija kao double: " << (double) pozicija << endl; // "Pozicija kao double: 51.000000"
	cout.flags(coutFlags | ios::scientific);  // ukljucujemo scientific prikaz, precision i dalje odredjuje broj cifara iza decimalne tacke
	cout << "Pozicija kao double: " << (double) pozicija << endl; // "Pozicija kao double: 5.100000e+001"
	cout.flags(cout.flags() & ~ios::scientific); // iskljucujemo scientific prikaz
	cout << "Pozicija kao double: " << (double) pozicija << endl; // "Pozicija kao double: 51"
	cout.flags(coutFlags); // vracamo format na polazno stanje

	// pomeramo se 0 mesta u odnosu na pocetak toka (ios::end za pomeraj u odnosu na kraj toka)
	dat1.seekg(0, ios::beg);
	
	pozicija = dat1.tellg(); 
	cout << "Pozicija: " << pozicija << endl;

	// ispisujemo sadrzaj datoteke na standardnom izlazu
	while(!dat1.eof())
	{
		dat1.getline(line, MAX_DUZ);
		if ('\0' != line[0]) 
			cout << line << "\n";
	}
	dat1.close();
}
